#!/bin/sh

cat <<EOF

ifndef OBJEXT
OBJEXT := o
endif

ifndef SRCDIR
SRCDIR := .
endif

EOF

for suf in "$@"
do

sed "s/suf/$suf/g" <<EOF

ifdef OBJDIR

$(OBJDIR)/%.$(OBJEXT): $(SRCDIR)/%suf
	-@mkdir -p $(dir \$@)
	$(CC) $(CFLAGS) -o \$@ -c $<

$(OBJDIR)/%.dep: $(SRCDIR)/%suf
	-@mkdir -p $(dir \$@)
	$(MAKEDEPEND) $(IFLAGS) $< | $(DEPENDFILTER) \$@ > \$@

else

%.o: %suf
	$(CC) $(CFLAGS) -o \$@ -c $<

%.depend: %suf
	$(MAKEDEPEND) $(IFLAGS) $< | $(DEPENDFILTER) \$@ > \$@

endif

EOF

done
echo 'ifdef DEPENDS'
echo 'include $(DEPENDS)'
echo 'endif'
