// header file for the position/velocity/acceleration, multiple measurement (position
// and velocity) model

#ifndef KALMANPVAMMV_H
#define KALMANPVAMMV_H

#include "kalmanbase.H"

class Pose;

// kalman filter for a position/velocity/accel model with a multiple  measurement
// (i.e., position and velocity)
class KalmanPVAMMV : public KalmanBase, public ExtendedKalmanBase,
                     public UnscentedKalmanBase
{
  public:
    KalmanPVAMMV();
    virtual ~KalmanPVAMMV();

    void initialize(double specd, double dt, double pn, double qn, 
                    double dv, int ukfflag);
    Pose * filter(Pose *userpos, double pinterval);

  protected: 
    int    _ctr;
    int    _ukfflag;
};


#endif
