// header file for the position/velocity, single measurement (position)

#ifndef KALMANPVSM_H
#define KALMANPVSM_H

#include "kalmanbase.H"

class Pose;

// kalman filter for a position/velocity model with a single measurement
class KalmanPVSM : public KalmanBase, public ExtendedKalmanBase,
		   public UnscentedKalmanBase
{
  public:
    KalmanPVSM();
    virtual ~KalmanPVSM();

   void initialize(double specd, double dt, double pn, double qn, int ukfflag);
    Pose * filter(Pose *userpos, double pinterval);

  protected: 
    int    _ctr;  // counter used for KF, EKF, and UKF
    int    _ukfflag; 
};


#endif
