// update functions for kalman filtering

#ifndef KALMANUPDATE_H
#define KALMANUPDATE_H

#include "mmatrix.H"


enum KALMANMODEL { kPVSM = 1, kPVASM = 2, kPVMMV = 3, kPVAMMV = 4, kPVAMMA = 5, kPVAMMVA = 6,kPSM = 7};



// helper class for updating states and matrices using quaternions 
class Updater
{
 public:
   Updater() { }
   virtual ~Updater() { }

   MMatrix RK4(const MMatrix &es, double dt, KALMANMODEL mod);
   MMatrix updateFundMat(const MMatrix &es, double dt, KALMANMODEL mod);
   MMatrix updateQMat(const MMatrix &es, double dt, double spd, KALMANMODEL mod);
   MMatrix updateHMat(const MMatrix &es, KALMANMODEL mod);

};


// helper class for updating states and matricies using the logexp mapping transform
class UpdaterLogExp
{
 public:
   UpdaterLogExp() { }
   virtual ~UpdaterLogExp() { }

   MMatrix RK4(const MMatrix &es, double dt, KALMANMODEL mod, double theta);
   MMatrix updateFundMat(const MMatrix &es, double dt, KALMANMODEL mod, double theta);
   MMatrix updateQMat(const MMatrix &es, double dt, double spd, 
                      KALMANMODEL mod, double theta);

};




#endif
